<template>
  <div class="main-header">
    <div class="logo" style="padding: 13px;">
      <img :src="asset('images/icons/lenna-logo-white.png')" style="width: 29pt; height: 29pt">
    </div>
    <div class="menu-toggle-lenna">
      <a :href="authUrl">
        <img :src="asset('images/ui_elements/ic_home.png')" width="26pt">
      </a>
    </div>
    <strong>
      <span
        style="font-size: 16pt; color: #003473;font-family: Poppins"
        class="d-sm-block d-none"
      >OMNICHANNELS</span>
    </strong>

    <div style="margin: auto"></div>

    <div class="header-part-right">
      <!-- Full screen toggle -->
      <!-- <i class="i-Full-Screen header-icon d-none d-sm-inline-block" data-fullscreen></i> -->
      <!-- Grid menu Dropdown -->
      <div class="dropdown">
        <div class="mr-4">
          <button class="btn bg-white border text-muted" data-toggle="dropdown">
            {{activeApp}}
            <i class="fas fa-caret-down"></i>
          </button>

          <div class="dropdown-menu dropdown-menu-right" aria-labelledby="userDropdown">
            <div class="dropdown-header">
              <i class="i-Computer-Secure mr-1"></i>
              Your Apps:
            </div>
            <a
              :href="`${appUrl}/${app.hashed_id}/dashboard`"
              v-for="app in appList"
              :key="app.id"
              class="text-muted dropdown-item"
            >{{app.name}}</a>
          </div>
        </div>
      </div>

      <!-- Notificaiton -->
      <div class="dropdown">
        <div
          class="badge-top-container"
          role="button"
          id="dropdownNotification"
          data-toggle="dropdown"
          aria-haspopup="true"
          aria-expanded="false"
        >
          <span class="badge badge-danger" v-show="showNotifCount">{{totalNotifCount}}</span>
          <img
            :src="asset('images/ui_elements/ic_notification.svg')"
            alt
            role="button"
            class="w-75 pointer"
          >
          <!-- <i class="i-Bell text-muted header-icon"></i> -->
        </div>
        <!-- Notification dropdown -->
        <div
          class="dropdown-menu dropdown-menu-right notification-dropdown"
          aria-labelledby="dropdownNotification"
          data-suppress-scroll-x="true"
          style="height:25vh;overflow-y:scroll"
        >
          <div v-if="notifList.length > 0">
            <template v-for="(notif,key) in notifList">
              <div class="dropdown-item d-flex" :key="key" @click="selectNotifHandler(notif)">
                <div class="notification-icon">
                  <i class="i-Speach-Bubble-6 text-primary mr-1"></i>
                </div>
                <div class="notification-details flex-grow-1">
                  <p class="text-small text-muted m-0">
                    <strong>{{getLastItem(notif,"title")}}</strong>
                  </p>

                  <p class="text-small text-muted m-0">{{getLastItem(notif,"body")}}</p>
                  <small class="text-muted m-0">{{getLastItem(notif,"created_at")}}</small>
                </div>
                <div class="flex">
                  <span class="badge badge-pill badge-danger ml-1 mr-1">{{notif.unread_count}}</span>
                </div>
              </div>
            </template>
          </div>

          <div class="dropdown-item d-flex" v-else>
            <div class="notification-icon">
              <i class="i-Speach-Bubble-6 text-primary mr-1"></i>
            </div>
            <div class="notification-details flex-grow-1">
              <!-- <p class="m-0 d-flex align-items-center">
                <span>Empty</span>
                <span class="badge badge-pill badge-primary ml-1 mr-1"></span>
                <span class="flex-grow-1"></span>
                <span class="text-small text-muted ml-auto"></span>
              </p>-->
              <p class="text-small text-muted m-0">Empty</p>
              <p class="text-small text-muted m-0">No Notification</p>
            </div>
          </div>

          <!-- <div class="dropdown-item d-flex">
            <div class="notification-icon">
              <i class="i-Receipt-3 text-success mr-1"></i>
            </div>
            <div class="notification-details flex-grow-1">
              <p class="m-0 d-flex align-items-center">
                <span>New order received</span>
                <span class="badge badge-pill badge-success ml-1 mr-1">new</span>
                <span class="flex-grow-1"></span>
                <span class="text-small text-muted ml-auto">2 hours ago</span>
              </p>
              <p class="text-small text-muted m-0">1 Headphone, 3 iPhone x</p>
            </div>
          </div>
          <div class="dropdown-item d-flex">
            <div class="notification-icon">
              <i class="i-Empty-Box text-danger mr-1"></i>
            </div>
            <div class="notification-details flex-grow-1">
              <p class="m-0 d-flex align-items-center">
                <span>Product out of stock</span>
                <span class="badge badge-pill badge-danger ml-1 mr-1">3</span>
                <span class="flex-grow-1"></span>
                <span class="text-small text-muted ml-auto">10 hours ago</span>
              </p>
              <p class="text-small text-muted m-0">Headphone E67, R98, XL90, Q77</p>
            </div>
          </div>
          <div class="dropdown-item d-flex">
            <div class="notification-icon">
              <i class="i-Data-Power text-success mr-1"></i>
            </div>
            <div class="notification-details flex-grow-1">
              <p class="m-0 d-flex align-items-center">
                <span>Server Up!</span>
                <span class="badge badge-pill badge-success ml-1 mr-1">3</span>
                <span class="flex-grow-1"></span>
                <span class="text-small text-muted ml-auto">14 hours ago</span>
              </p>
              <p class="text-small text-muted m-0">Server rebooted successfully</p>
            </div>
          </div>-->
        </div>
      </div>
      <!-- Notificaiton End -->
      <!-- User avatar dropdown -->
      <div class="dropdown">
        <div class="user col align-self-end">
          <img
            src="https://cdn.zeplin.io/5a17206501b10a0c811739fa/assets/3A5589A5-2E48-4402-9742-15F0561D6C7E.png"
            id="userDropdown"
            alt
            data-toggle="dropdown"
            aria-haspopup="true"
            aria-expanded="false"
            class="pointer"
          >

          <div class="dropdown-menu dropdown-menu-right" aria-labelledby="userDropdown">
            <div class="dropdown-header">
              <i class="i-Lock-User mr-1"></i>
              {{user.name}}
            </div>
            <!-- <a class="dropdown-item">Account settings</a>
            <a class="dropdown-item">Billing history</a>-->
            <a class="dropdown-item" @click.prevent="logout">Sign out</a>
          </div>
        </div>
      </div>
    </div>
  </div>
  <!-- header top menu end -->
</template>

<script>
export default {
  data() {
    return {
      user: this.$store.getters.localStorage.user,
      appList: null,
      appUrl: process.env.MIX_APP_URL,
      appId: this.$store.getters.appId.hashed,
      activeApp: "loading"
    };
  },
  computed: {
    notifList() {
      return this.$store.getters["notification/notifList"];
    },
    totalNotifCount() {
      let count = 0;
      for (const obj of this.notifList) {
        count += obj.unread_count;
      }
      return count;
    },
    showNotifCount() {
      if (this.totalNotifCount > 0) {
        return true;
      }
      return false;
    }
  },
  methods: {
    selectNotifHandler(data) {
      this.$store.dispatch("notification/selectNotif", {
        ...data
      });
      switch (data.type) {
        case "chat-message":
          if (this.$route.name != "chat") {
            this.$router.push({
              name: "chat",
              params: { fromNotif: true, ...data }
            });
          } else {
            this.$store.dispatch("chat/selectRoom", {
              room: data.data.room,
              forceUpdate: true,
              senderId: this.$store.getters.localStorage.decodedUserId
            });
          }
          break;

        case "live-request":
          if (this.$route.name != "chat") {
            this.$router.push({
              name: "chat",
              params: { fromNotif: true, ...data }
            });
          } else {
            this.$store.dispatch("chat/selectRoom", {
              room: data.data.room,
              forceUpdate: true,
              senderId: this.$store.getters.localStorage.decodedUserId
            });
          }
          break;

        default:
          break;
      }
    },
    getLastItem(data, content) {
      //   let lastNotif = _.last(data);
      let lastItem = _.last(data.items);

      switch (content) {
        case "body":
          if (lastItem.body.length > 15) {
            return lastItem.body.substr(0, 15) + "..";
          }
          return lastItem.body;
          break;
        default:
          return lastItem[content];
          break;
      }
    },
    substringText(text) {
      if (text.length > 15) {
        return text.substr(0, 15) + "..";
      }
      return text;
    },
    logout() {
      axios.defaults.headers.common["Authorization"] =
        "Bearer " + this.$store.getters.localStorage.user.token.access_token;
      axios
        .post(process.env.MIX_AUTH_URL + "/api/logout")
        .then(
          localStorage.removeItem("user"),
          (window.location.href = process.env.MIX_AUTH_URL + "/login")
        );
    }
  },
  async mounted() {
    await this.$store.dispatch("notification/getNotifList");

    let response = await this.$axiosNoLoading.get(
      process.env.MIX_AUTH_URL + `/api/apps/${this.user.id}`
    );
    this.appList = response.data;
    this.activeApp =
      _.find(this.appList, o => {
        return o.hashed_id == this.appId;
      }).name || "loading";
  }
};
</script>

<style lang="scss" scoped>
.main-header {
  background: rgb(245, 245, 245);
}
.menu-toggle-lenna {
  width: 60px;
  display: flex;
  flex-direction: column;
  align-items: center;
  cursor: pointer;
}
.list-group {
  .list-group-item {
    border: none;
  }
}
.dropdown-menu {
  width: 20vw !important;
  word-break: break-word !important;
}
.dropdown-item {
  white-space: normal !important;
  &:active {
    background: #fdfdfd !important;
  }
}
.badge-top-container .badge {
  top: -5px !important;
  right: -5px !important;
}
.main-header {
  padding: 0;
}
@media (max-width: 576px) {
  .main-header .logo {
    width: 60px;
  }
}
.select-app {
  width: 100px;
  background: white;
  height: 4vh;
}
</style>
